<?php

namespace Internetgalerie\IgCrmTemplate\ViewHelpers;

use Internetgalerie\IgCrmTemplate\Domain\Model\TemplatePageLayout;
use Internetgalerie\IgCrmTemplate\Utility\TemplateUtility;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;

class PageLayoutViewHelper extends AbstractViewHelper
{
    protected $escapeOutput = false;
    
    
    /**
     * Initialize the arguments.
     * @api
     */
    public function initializeArguments()
    {
        parent::initializeArguments();
        $this->registerArgument('templatePageLayout', TemplatePageLayout::class, 'templatePageLayout', true);
        //$this->registerArgument('type', 'string', 'template to use', false, null);
    }

    /**
     * Content Renderer
     * @return string
     */
    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    ) {
        $templateUtility = GeneralUtility::makeInstance(TemplateUtility::class);

        $templatePageLayout = $arguments['templatePageLayout'];

        $html = '';
        /*
          $css = '';
          $headerRight = '';
          if ($templatePageLayout->getHeaderRightTemplate()) {
          $headerRight = $templatePageLayout->getHeaderRightTemplate();
          if ($headerRight) {
          $headerRight = $renderingContext->getTemplateParser()->parse($headerRight)->render($renderingContext);
          }
          }
          if ($headerRight) {
          $html .= '<div class="ig-crm-template-box-top-right" id="ig-crm-template-box-top-right">'. $headerRight . '</div>';
          $css .= '@top-right {
          content: element(igCrmTemplateBoxTopRightElement);
          }';
          }
        */

        $html = $templateUtility->renderCssPagedMediaMarginBoxs($templatePageLayout, $renderingContext);
        $html .= $renderChildrenClosure();
    
        return $html;
    }
}
